/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the Settings type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Settings{}

// Settings struct for Settings
type Settings struct {
	TriggerTemplates []TriggerTemplate `json:"trigger_templates"`
	Actions []ActionType `json:"actions"`
	// It`s a map of DataSourceProperties index by DataSource
	DataSources *map[string]DataSourceProperties `json:"data_sources,omitempty"`
	// It`s a map of Operator list index by DataType
	DataTypeOperators *map[string][]Operator `json:"data_type_operators,omitempty"`
	// It`s a map of ActionSchemas indexed by ActionType
	ActionsSchemas map[string]interface{} `json:"actions_schemas,omitempty"`
}

// NewSettings instantiates a new Settings object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSettings(triggerTemplates []TriggerTemplate, actions []ActionType) *Settings {
	this := Settings{}
	this.TriggerTemplates = triggerTemplates
	this.Actions = actions
	return &this
}

// NewSettingsWithDefaults instantiates a new Settings object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSettingsWithDefaults() *Settings {
	this := Settings{}
	return &this
}

// GetTriggerTemplates returns the TriggerTemplates field value
func (o *Settings) GetTriggerTemplates() []TriggerTemplate {
	if o == nil {
		var ret []TriggerTemplate
		return ret
	}

	return o.TriggerTemplates
}

// GetTriggerTemplatesOk returns a tuple with the TriggerTemplates field value
// and a boolean to check if the value has been set.
func (o *Settings) GetTriggerTemplatesOk() ([]TriggerTemplate, bool) {
	if o == nil {
		return nil, false
	}
	return o.TriggerTemplates, true
}

// SetTriggerTemplates sets field value
func (o *Settings) SetTriggerTemplates(v []TriggerTemplate) {
	o.TriggerTemplates = v
}

// GetActions returns the Actions field value
func (o *Settings) GetActions() []ActionType {
	if o == nil {
		var ret []ActionType
		return ret
	}

	return o.Actions
}

// GetActionsOk returns a tuple with the Actions field value
// and a boolean to check if the value has been set.
func (o *Settings) GetActionsOk() ([]ActionType, bool) {
	if o == nil {
		return nil, false
	}
	return o.Actions, true
}

// SetActions sets field value
func (o *Settings) SetActions(v []ActionType) {
	o.Actions = v
}

// GetDataSources returns the DataSources field value if set, zero value otherwise.
func (o *Settings) GetDataSources() map[string]DataSourceProperties {
	if o == nil || IsNil(o.DataSources) {
		var ret map[string]DataSourceProperties
		return ret
	}
	return *o.DataSources
}

// GetDataSourcesOk returns a tuple with the DataSources field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Settings) GetDataSourcesOk() (*map[string]DataSourceProperties, bool) {
	if o == nil || IsNil(o.DataSources) {
		return nil, false
	}
	return o.DataSources, true
}

// HasDataSources returns a boolean if a field has been set.
func (o *Settings) HasDataSources() bool {
	if o != nil && !IsNil(o.DataSources) {
		return true
	}

	return false
}

// SetDataSources gets a reference to the given map[string]DataSourceProperties and assigns it to the DataSources field.
func (o *Settings) SetDataSources(v map[string]DataSourceProperties) {
	o.DataSources = &v
}

// GetDataTypeOperators returns the DataTypeOperators field value if set, zero value otherwise.
func (o *Settings) GetDataTypeOperators() map[string][]Operator {
	if o == nil || IsNil(o.DataTypeOperators) {
		var ret map[string][]Operator
		return ret
	}
	return *o.DataTypeOperators
}

// GetDataTypeOperatorsOk returns a tuple with the DataTypeOperators field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Settings) GetDataTypeOperatorsOk() (*map[string][]Operator, bool) {
	if o == nil || IsNil(o.DataTypeOperators) {
		return nil, false
	}
	return o.DataTypeOperators, true
}

// HasDataTypeOperators returns a boolean if a field has been set.
func (o *Settings) HasDataTypeOperators() bool {
	if o != nil && !IsNil(o.DataTypeOperators) {
		return true
	}

	return false
}

// SetDataTypeOperators gets a reference to the given map[string][]Operator and assigns it to the DataTypeOperators field.
func (o *Settings) SetDataTypeOperators(v map[string][]Operator) {
	o.DataTypeOperators = &v
}

// GetActionsSchemas returns the ActionsSchemas field value if set, zero value otherwise.
func (o *Settings) GetActionsSchemas() map[string]interface{} {
	if o == nil || IsNil(o.ActionsSchemas) {
		var ret map[string]interface{}
		return ret
	}
	return o.ActionsSchemas
}

// GetActionsSchemasOk returns a tuple with the ActionsSchemas field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Settings) GetActionsSchemasOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.ActionsSchemas) {
		return map[string]interface{}{}, false
	}
	return o.ActionsSchemas, true
}

// HasActionsSchemas returns a boolean if a field has been set.
func (o *Settings) HasActionsSchemas() bool {
	if o != nil && !IsNil(o.ActionsSchemas) {
		return true
	}

	return false
}

// SetActionsSchemas gets a reference to the given map[string]interface{} and assigns it to the ActionsSchemas field.
func (o *Settings) SetActionsSchemas(v map[string]interface{}) {
	o.ActionsSchemas = v
}

func (o Settings) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Settings) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["trigger_templates"] = o.TriggerTemplates
	toSerialize["actions"] = o.Actions
	if !IsNil(o.DataSources) {
		toSerialize["data_sources"] = o.DataSources
	}
	if !IsNil(o.DataTypeOperators) {
		toSerialize["data_type_operators"] = o.DataTypeOperators
	}
	if !IsNil(o.ActionsSchemas) {
		toSerialize["actions_schemas"] = o.ActionsSchemas
	}
	return toSerialize, nil
}

type NullableSettings struct {
	value *Settings
	isSet bool
}

func (v NullableSettings) Get() *Settings {
	return v.value
}

func (v *NullableSettings) Set(val *Settings) {
	v.value = val
	v.isSet = true
}

func (v NullableSettings) IsSet() bool {
	return v.isSet
}

func (v *NullableSettings) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSettings(val *Settings) *NullableSettings {
	return &NullableSettings{value: val, isSet: true}
}

func (v NullableSettings) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSettings) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


